;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;:  Compressio
;:  Autor: CKENER
;:  email: ckener452@terra.com.mx
;:  http://kickme.to/askatasunakrackers
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

; bitio12.asm

  COMMENT *
  Algoritmo: BitIO (Bit Input & Output)
  Implementado por: Ckener
  Versin: 1.2
  *

; ########################################################################

  BitIO_Init         PROTO
  BitInput           PROTO
  BitOutput          PROTO
  BitIO_Finish       PROTO

; ########################################################################

 .DATA?

  dwInicio       DWORD ?
  dwDestino      DWORD ?
  dwLongitud     DWORD ?

; ########################################################################

 .CODE

; ########################################################################

  BitIO_Init proc

   ;parmetros
   ;~~~~~~~~~~
   ;[ebp+08h] = direccin donde se empezara a escribir/leer

   ;valores de retorno
   ;~~~~~~~~~~~~~~~~~~
   ;no hay valores de retorno

	push ebp
	mov ebp, esp

	mov eax, dword ptr [ebp+08h]
	mov dwInicio, eax
	mov dwDestino, eax
	mov dwLongitud, NULL

	mov esp, ebp
	pop ebp
	ret 04h
  BitIO_Init endp

; ########################################################################

  BitInput proc

   ;parmetros
   ;~~~~~~~~~~
   ;[ebp+08h] = numero de bits a leer

   ;valores de retorno
   ;~~~~~~~~~~~~~~~~~~
   ;eax = bits ledos

	push ebp
	mov ebp, esp

	push ebx
	push ecx
	push edx
	push edi

	mov ebx, dword ptr [ebp+08h]
	mov edx, dwLongitud
	mov edi, dwDestino
	mov eax, dword ptr [edi]

	add edx, ebx
	cmp edx, 20h
	ja @mas

	mov ecx, 20h
	sub ecx, edx
	shl eax, cl
	add ecx, dwLongitud
	cmp ecx, 20h
	jb @@1
	xor eax, eax
	@@1:
	shr eax, cl
	add dwLongitud, ebx
	jmp @ret

	@mas:
	mov ecx, dwLongitud
	cmp ecx, 20h
	jb @@2
	xor eax, eax
	@@2:
	shr eax, cl
	sub edx, 20h
	mov dwLongitud, edx
	mov ebx, dword ptr [edi+04h]
	mov ecx, 20h
	sub ecx, dwLongitud
	cmp ecx, 20h
	jb @@3
	xor ebx, ebx
	@@3:
	shl ebx, cl
	shr ebx, cl
	mov ecx, dword ptr [ebp+08h]
	sub ecx, edx
	cmp ecx, 20h
	jb @@4
	xor ebx, ebx
	@@4:
	shl ebx, cl
	or eax, ebx	
	add dwDestino, 04h

	@ret:
	pop edi
	pop edx
	pop ecx
	pop ebx

	mov esp, ebp
	pop ebp
	ret 04h
  BitInput endp

; ########################################################################

  BitOutput proc

   ;parmetros
   ;~~~~~~~~~~
   ;[ebp+08h] = bits a escribir
   ;[ebp+0Ch] = longitud, en bits

   ;valores de retorno
   ;~~~~~~~~~~~~~~~~~~
   ;no hay valores de retorno

	push ebp
	mov ebp, esp

	push ebx
	push ecx
	push edx
	push edi

	mov ebx, dword ptr [ebp+0Ch]

	mov edi, dwDestino
	mov eax, dword ptr [edi]
	mov ecx, dwLongitud
	mov edx, dword ptr [ebp+08h]

	cmp ecx, 20h
	jb @@1
	xor edx, edx
	@@1:
	shl edx, cl
	or eax, edx
	add ecx, ebx
	mov dword ptr [edi], eax

	cmp ecx, 20h
	jb @ok

	lea ebx, dword ptr [ecx-20h]
	mov eax, dword ptr [ebp+08h]
	mov ecx, dword ptr [ebp+0Ch]
	sub ecx, ebx
	cmp ecx, 20h
	jb @@2
	xor eax, eax
	@@2:
	shr eax, cl
	mov dword ptr [edi+04h], eax
	mov ecx, ebx
	add dwDestino, 04h

	@ok:
	mov dwLongitud, ecx

	@ret:
	pop edi
	pop edx
	pop ecx
	pop ebx

	mov esp, ebp
	pop ebp
	ret 08h
  BitOutput endp

; ########################################################################

  BitIO_Finish proc

   ;parmetros
   ;~~~~~~~~~~
   ;no recibe parmetros

   ;valores de retorno
   ;~~~~~~~~~~~~~~~~~~
   ;eax = numero total de bytes escritos/ledos

	push ebp
	mov ebp, esp

	mov eax, dwDestino
	sub eax, dwInicio

	cmp dwLongitud, 08h
	ja @2
	add eax, 01h
	jmp @ok

	@2:
	cmp dwLongitud, 10h
	ja @3
	add eax, 02h
	jmp @ok

	@3:
	cmp dwLongitud, 18h
	ja @4
	add eax, 03h
	jmp @ok

	@4:
	add eax, 04h

	@ok:
	mov dwInicio, NULL
	mov dwDestino, NULL
	mov dwLongitud, NULL

	mov esp, ebp
	pop ebp
	ret
  BitIO_Finish endp

; ########################################################################