;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;:  Compressio
;:  Autor: CKENER
;:  email: ckener452@terra.com.mx
;:  http://kickme.to/askatasunakrackers
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

; crc12.asm

  COMMENT *
  Algoritmo: CRC32 (Cyclic Redundancy Code 32 bits)
  Implementado por: Ckener
  Versin: 1.2
  *

  INCLUDE crc.inc

; ########################################################################

  GetDataCRC        PROTO
  GetSubsequentCRC  PROTO

; ########################################################################

 .CODE

; ########################################################################

  GetDataCRC proc

   ;parmetros
   ;~~~~~~~~~~
   ;[ebp+08h] = direccin del buffer con los datos
   ;[ebp+0Ch] = tamao, en bytes, de los datos

   ;locales
   ;~~~~~~~
   ;[ebp-04h] = CRC

   ;valores de retorno
   ;~~~~~~~~~~~~~~~~~~
   ;eax = CRC

	push ebp
	mov ebp, esp
	sub esp, 04h

	pushad

	mov edi, offset CRCTable
	mov esi, dword ptr [ebp+08h]
	mov ebx, dword ptr [ebp+0Ch]
	xor ecx, ecx
	or eax, 0FFFFFFFFh

	@docrc:
	xor edx, edx
	mov dl, byte ptr [esi]
	inc esi
	inc ecx
	xor edx, eax
	and edx, 0FFh
	shr eax, 08h
	xor eax, dword ptr [edx*04h+edi]
	cmp ecx, ebx
	jb @docrc
	xor eax, 0FFFFFFFFh
	mov dword ptr [ebp-04h], eax

	popad
	mov eax, dword ptr [ebp-04h]

	mov esp, ebp
	pop ebp
	ret 08h
  GetDataCRC endp

; ########################################################################

  GetSubsequentCRC proc

   ;parmetros
   ;~~~~~~~~~~
   ;[ebp+08h] = CRC inicial
   ;[ebp+0Ch] = direccin del buffer con los datos
   ;[ebp+10h] = tamao, en bytes, de los datos

   ;locales
   ;~~~~~~~
   ;[ebp-04h] = CRC

   ;valores de retorno
   ;~~~~~~~~~~~~~~~~~~
   ;eax = CRC

	push ebp
	mov ebp, esp
	sub esp, 04h

	pushad

	mov edi, offset CRCTable
	mov eax, dword ptr [ebp+08h]
	mov esi, dword ptr [ebp+0Ch]
	mov ebx, dword ptr [ebp+10h]
	xor ecx, ecx

	@crc:
	xor edx, edx
	mov dl, byte ptr [esi]
	inc esi
	inc ecx
	xor edx, eax
	and edx, 0FFh
	shr eax, 08h
	xor eax, dword ptr [edx*04h+edi]
	cmp ecx, ebx
	jb @crc
	mov dword ptr [ebp-04h], eax

	popad
	mov eax, dword ptr [ebp-04h]

	mov esp, ebp
	pop ebp
	ret 0Ch
  GetSubsequentCRC endp

; ########################################################################