;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;:  Compressio
;:  Autor: CKENER
;:  email: ckener452@terra.com.mx
;:  http://kickme.to/askatasunakrackers
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

; 12_4.asm

  COMMENT *
  Algoritmo: LZ77 (Lempel, Ziv, Storer, Szymanski)
  Implementado por: Ckener
  Versin: 1.0
  *

; ########################################################################

  LZSS_GetBestMatch   PROTO
  LZSS_Encode         PROTO
  LZSS_Decode         PROTO

; ########################################################################

 .CODE

; ########################################################################
 
  LZSS_GetBestMatch proc

   ;parmetros
   ;~~~~~~~~~~
   ;[ebp+08h] = direccin de la posicin actual
   ;[ebp+0Ch] = direccin de la ventana
   ;[ebp+10h] = direccin del final de los datos

   ;locales
   ;~~~~~~~
   ;[ebp-04h] = match_offset
   ;[ebp-08h] = longitud

   ;valores de retorno
   ;~~~~~~~~~~~~~~~~~~
   ;eax = offset y longitud de la ocurrencia

	push ebp
	mov ebp, esp
	sub esp, 08h

	pushad

	mov edx, dword ptr [ebp+08h]
	mov edi, dword ptr [ebp+0Ch]
	mov ebx, dword ptr [ebp+10h]

	mov dword ptr [ebp-04h], NULL
	mov dword ptr [ebp-08h], NULL

	dec edi
	@nueva_busqueda:
	mov esi, dword ptr [ebp+08h]
	mov al, byte ptr [esi]

	@buscar_simbolo:
	inc edi
	cmp edi, esi
	je @fin_ventana
	cmp byte ptr [edi], al
	jne @buscar_simbolo

	xor ecx, ecx
	push edi

	@match_len:
	inc ecx
	inc esi
	inc edi
	cmp edx, edi
	je @fin_match
	cmp ebx, esi
	je @fin_match
	cmp ecx, 12h
	je @fin_match
	mov al, byte ptr [esi]
	cmp byte ptr [edi], al
	je @match_len

	@fin_match:
	pop edi

	cmp ecx, 03h
	jb @nueva_busqueda

	cmp dword ptr [ebp-08h], ecx
	jae @nueva_busqueda

	mov dword ptr [ebp-04h], edi
	mov dword ptr [ebp-08h], ecx
	jmp @nueva_busqueda

	@fin_ventana:
	popad
	cmp dword ptr [ebp-08h], NULL
	je @ret

	mov eax, dword ptr [ebp+08h]
	sub eax, dword ptr [ebp-04h]
	shl eax, 04h

	sub dword ptr [ebp-08h], 03h
	or eax, dword ptr [ebp-08h]

	mov esp, ebp
	pop ebp
	ret 0Ch

	@ret:
	mov eax, 0FFFFFFFFh

	mov esp, ebp
	pop ebp
	ret 0Ch
  LZSS_GetBestMatch endp

; ########################################################################
 
  LZSS_Encode proc

   ;parmetros
   ;~~~~~~~~~~
   ;[ebp+08h] = direccin del buffer con los datos a comprimir
   ;[ebp+0Ch] = tamao, en bytes, de los datos a comprimir
   ;[ebp+10h] = direccin del buffer para los datos comprimidos

   ;valores de retorno
   ;~~~~~~~~~~~~~~~~~~
   ;eax = numero de bytes comprimidos

	push ebp
	mov ebp, esp

	pushad

	mov esi, dword ptr [ebp+08h]
	mov ebx, dword ptr [ebp+0Ch]
	mov edi, esi
	add ebx, esi

	push dword ptr [ebp+10h]
	call BitIO_Init

	mov eax, dword ptr [esi]
	and eax, 00FFFFFFh
	push 18h
	push eax
	call BitOutput
	add esi, 03h

	@sig_byte:
	lea edx, dword ptr [esi-0FFFh]
	cmp edi, edx
	jb @ventana_ok
	mov edx, dword ptr [ebp+08h]

	@ventana_ok:
	push ebx
	push edx
	push esi
	call LZSS_GetBestMatch
	cmp eax, 0FFFFFFFFh
	je @no_match

	mov ecx, eax
	and ecx, 0Fh
	lea esi, dword ptr [esi+ecx+03h]

	lea eax, dword ptr [eax+eax+01h]
	push 11h
	push eax
	call BitOutput

	cmp esi, ebx
	jb @sig_byte
	jmp @fin

	@no_match:
	xor eax, eax
	mov al, byte ptr [esi]
	inc esi
	add eax, eax
	push 09h
	push eax
	call BitOutput

	cmp esi, ebx
	jb @sig_byte

	@fin:
	popad
	call BitIO_Finish

	mov esp, ebp
	pop ebp
	ret 0Ch
  LZSS_Encode endp

; ########################################################################

  LZSS_Decode proc

   ;parmetros
   ;~~~~~~~~~~
   ;[ebp+08h] = direccin del buffer con los datos a descomprimir
   ;[ebp+0Ch] = tamao, en bytes, de los datos originales
   ;[ebp+10h] = direccin del buffer para los datos a descomprimir

   ;valores de retorno
   ;~~~~~~~~~~~~~~~~~~
   ;no hay valores de retorno

	push ebp
	mov ebp, esp

	pushad

	mov ebx, dword ptr [ebp+0Ch]
	mov edi, dword ptr [ebp+10h]
	add ebx, edi

	push dword ptr [ebp+08h]
	call BitIO_Init

	push 24
	call BitInput
	mov dword ptr [edi], eax
	add edi, 03h

	@sig_flag:
	push 01h
	call BitInput
	test eax, eax
	jz @byte

	push 10h
	call BitInput
	mov ecx, eax
	shr eax, 04h
	and ecx, 0Fh
	add ecx, 03h
	mov edx, edi
	sub edx, eax

	@sig_byte:
	dec ecx
	mov al, byte ptr [edx]
	mov byte ptr [edi], al
	inc edx
	inc edi
	test ecx, ecx
	jnz @sig_byte

	cmp edi, ebx
	jb @sig_flag
	jmp @fin

	@byte:
	push 08h
	call BitInput
	mov byte ptr [edi], al
	inc edi
	cmp edi, ebx
	jb @sig_flag
	
	@fin:
	popad
	call BitIO_Finish

	mov esp, ebp
	pop ebp
	ret 0Ch
  LZSS_Decode endp

; ########################################################################